// Remove this file on final merge. 

#include <cis-workflow-gen/quick-include.hpp>

int main() {
    #define GEN_TASKNAME(taskname) (std::string(task_parent_note) + "." + taskname)
    #define A_2(task, entityName) ManualOperation("Task notice: " + GEN_TASKNAME(#task), "Hey, team. You need to build " +GEN_TASKNAME(#task)+ ". Please resolve this ICM incident IF AND ONLY IF you have finished this task. ", teamid, #entityName)
    #define A_1(arg1) A_2(arg1, )
    #define A_proxy(x, Arg1, Arg2, FUNC, ...) FUNC
    #define A(...) A_proxy(, ##__VA_ARGS__, A_2(__VA_ARGS__), A_1(__VA_ARGS__))
    #define AV(task, entityName) Noop("Virtual task: "#task, #entityName)

    auto task_parent_note = "EOP";
    auto teamid = "GCBuild";

    auto eopBody = 
    /*148*/ A(EOPServerDock) >> 
    /*149*/ A(EOPServerRTEG) >> 
    /*151*/ A(ConfigCheckin_And_ImportInventory) >> 
    /*152*/ A(EOPNetworkPrep) >> 
    /*153*/ A(RackElevation_And_ServerImport) >> 
    /*154*/ A(BurninPayload) >> 
    /*156*/ A(NewForestCreation) >> 
    /*157*/ A(GLSSetup_And_CNAMECreation, M365GoLocal.EOP.GLSAndCNAME) >> 
    /*158*/ A(StatefulFlattening) >> 
    /*159*/ A(DBDeployment) >> 
    /*160*/ A(StatelessDeployment, M365GoLocal.EOP.StatelessDeployment) >> 
    /*162*/ A(ForwardSync) >> 
    /*163*/ A(GTMGLSDNSConfigurations) >> 
    /*164*/ A(TestTenantCreation) >> 
    /*165*/ A(ValidationandComponentSignoff, M365GoLocal.EOP.Validation) >> 
    /*166*/ A(WorkloadIntegrationwithEXO) >> 
    /*167*/ AV(EOPEngineeringReadinessSweden, M365GoLocal.EOP.EngineeringReadiness);

    auto flowEop = 
    /*147*/ A(TAMAward) | 
        eopBody;
    
    println(to_file("EOPWorkflow.xaml"), flowEop.generateXaml("Microsoft.Office.FleetAGC.Workflows.SwedenBuildout.EOP"));

    task_parent_note = "SPO";
    auto flowSpo = 
    /*114*/ A(TAMAward) | (
        /*115*/ A(SPOServer_And_NetworkDock, M365GoLocal.SPO.Dock) >> 
        /*116*/ A(SPOServer_And_NetworkRTEG) >> 
        /*119*/ A(ServerValidationNetwork_And_Hardware) >> 
        /*120*/ A(ServerImaging) >> 
        /*121*/ A(AzureSubscription_And_SubmitandValidateConsumption) >> 
        /*123*/ A(SPOFarmDeployments, M365GoLocal.SPO.FarmDeployment) >> (
            /*124*/ A(SPOPostDeploymentValidation) | (
            /*126*/ A(MicroservicesDeployment, M365GoLocal.SPO.MicroServices) >> 
            /*127*/ A(MicroservicesPostDeploymentValidation)
            ) >> 
            /*128*/ AV(ServiceReadiness, M365GoLocal.SPO.ServiceReadiness) >> 
            /*129*/ AV(WorkloadIntegration, M365GoLocal.SPO.WorkloadIntegration) >>
            /*130*/ AV(SPOEngineeringReadinessSweden, M365GoLocal.SPO.EngineeringReadiness)
        )
    );

    println(to_file("SPOWorkflow.xaml"), flowSpo.generateXaml("Microsoft.Office.FleetAGC.Workflows.SwedenBuildout.SPO"));

    task_parent_note = "EXO";
    auto flowExo = 
    /*86*/    A(Backends_TAMAward) | 
    /*96*/    A(CAFE_Substrate_TAMAward) |
    ( // begin the huge body
    ( // dep group of 100
    /*8384*/ (A(ActiveDirectoryDock) >> A(ActiveDirectoryRteg, M365GoLocal.EXO.ActiveDirectoryRteg)) | 
    /*8788*/ (A(BackEndsDock) >> A(BackEndsRteg)) |
    /*9091*/ (A(ManagementDock) >> A(ManagementRteg)) |
    /*9394*/ (A(CafeDock) >> A(CafeRteg)) |
    /*9798*/ (A(SubstrateDock) >> A(SubstrateRteg))
    ) >> 
    /*100*/ A(DiscoveryADBackEndCafeSubstrateAllocationofServersIPsandRoles, M365GoLocal.EXO.IPAllocationDiscovery) >> 
    /*101*/ AV(ApplicationDeployment, M365GoLocal.EXO.ApplicationDeployment) >> 
    /*102*/ A(ResourceForestDeployment) >> 
    /*103*/ A(Backend_And_FrontEndDeployment) >> 
    /*104*/ A(CapacityUnitPrepDAG_And_CAFE, M365GoLocal.EXO.CapacityUnitPrep) >> 
    /*106*/ A(ComponentValidation, M365GoLocal.EXO.ServiceReadiness) >> 
    /*107*/ A(Bugfix_And_Hotfixes) >> 
    /*108*/ A(MonitoringSetup, M365GoLocal.EXO.MonitoringSetup) >> 
    /*109*/ A(WorkloadIntegration, M365GoLocal.EXO.WorkloadIntegration) >> 
    /*110*/ AV(EXOEngineeringReadinessSweden, M365GoLocal.EXO.EngineeringReadiness)
    ); // end the huge body. 

    println(to_file("EXOWorkflow.xaml"), flowExo.generateXaml("Microsoft.Office.FleetAGC.Workflows.SwedenBuildout.EXO"));

    task_parent_note = "FastSearch";
    auto flowFS = 
    /*134*/ A(RTEGAzureResources, M365GoLocal.FastSearch.AzureResources) | 
    /*135136*/ (A(Dock, M365GoLocal.FastSearch.Dock) >> A(RTEG)) >> 
    /*138*/ AV(InfrastuctureDeployment, ) >>
    (
    /*139*/ A(ServerValidationNetwork_And_Hardware) >> 
    /*140*/ A(ServerImaging) >> 
    /*141*/ A(AzureSubscription_And_SubmitandValidateConsumption)
    ) | 
    /*142*/ A(FASTDeployment);
    // Node143 depends on nothing in this workflow. I don't know where to put it. Wait for the email reply, I believe it depends on 141+142. 
    /*143*/ AV(FASTEngineeringReadinessSweden, M365GoLocal.FastSearch.EngineeringReadiness);

    println(to_file("FastSearchWorkflow.xaml"), flowFS.generateXaml("Microsoft.Office.FleetAGC.Workflows.SwedenBuildout.FastSearch"));

    task_parent_note = "Wac";
    auto flowWac = 
    /*171*/ A(RTEGAzureResources, M365GoLocal.WAC.AzureResources) >> 
    /*173*/ A(InfrastructureDeployment) >> 
    /*174*/ A(ServiceDeployment) >> 
    /*175*/ AV(ServiceReadiness, ) >> 
    /*176*/ AV(WACEngineeringReadinessSweden, M365GoLocal.WAC.EngineeringReadiness);

    println(to_file("WACWorkflow.xaml"), flowWac.generateXaml("Microsoft.Office.FleetAGC.Workflows.SwedenBuildout.WAC"));

    task_parent_note = "OCS";
    auto flowOcs = 
    /*180*/ A(RtegAzureResources, M365GoLocal.OCS.AzureResources) >> 
    /*182*/ A(infrastuctureDeployment) >> 
    /*183*/ A(ServiceDeployment) >> 
    /*184*/ AV(ServiceReadiness, ) >> 
    /*185*/ AV(OCSEngineeringReadinessSweden, M365GoLocal.OCS.EngineeringReadiness);

    println(to_file("OCSWorkflow.xaml"), flowOcs.generateXaml("Microsoft.Office.FleetAGC.Workflows.SwedenBuildout.OCS"));

    task_parent_note = "Teams";
    auto flowTeams = 
    ( // first half begin
    /*188*/ AV(TeamsRTEG, ) >> 
    /*189*/ A(PreRegCompute) | 
    /*190*/ A(RTEGAzureResources, M365GoLocal.Teams.AzureResources)
    ) | ( // second half begin
    /*192*/ A(ServicesDeployment) >> 
    /*193*/ A(TestingandStamping) >> 
    /*194*/ A(TeamsEngineeringReadinessSweden, M365GoLocal.Teams.EngineeringReadiness)
    );

    println(to_file("TeamsWorkflow.xaml"), flowTeams.generateXaml("Microsoft.Office.FleetAGC.Workflows.SwedenBuildout.Teams"));

    task_parent_note = "CountryLaunch";
    auto flowCL = 
    // I believe that, all of them should be Virtual Activity... (Use Noop)
    /*196*/ AV(SwedenGAWorkloadAvailability, M365GoLocal.CountryLaunch.GAWorkloadAvailability) >> 
    /*197*/ A(SwedenGABakePeriod) >> 
    /*198*/ A(SwedenGAMarketingRelease);

    println(to_file("CountryLaunchWorkflow.xaml"), flowCL.generateXaml("Microsoft.Office.FleetAGC.Workflows.SwedenBuildout.CountryLaunch"));

  

}

